//---------------------------------------------------------------------------

#include <vcl.h>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

bool absLess (int elem1, int elem2)
{
    return abs(elem1) < abs(elem2);
}

int main()
{
  deque<int> coll;

  INSERT_ELEMENTS(coll,2,8);
  INSERT_ELEMENTS(coll,-3,5);

  PRINT_ELEMENTS(coll," :\n");

    //      
    cout << ToRus(":  ")
         << *min_element(coll.begin(),coll.end())
         << endl;
    cout << ToRus(": ")
         << *max_element(coll.begin(),coll.end())
         << endl;

    //      
    //   
    cout << ToRus("  :  ")
         << *min_element(coll.begin(),coll.end(),
                         absLess)
         << endl;
    cout << ToRus("  : ")
         << *max_element(coll.begin(),coll.end(),
                         absLess)
         << endl;


  getch();
  return 0;
}

//---------------------------------------------------------------------------